/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rpn;

import java.math.BigDecimal;
import java.util.ArrayDeque;
import java.util.Arrays;
import java.util.Deque;
import java.util.List;

/**
 *
 * @author me
 */
public class ReversePolishNotation 
{
    
    private static final String OPERATORS = "+-*/";
    
    public static BigDecimal evalRPN(String[] params)
    {
        return evalRPN(Arrays.asList(params));
    }
    
    public static BigDecimal evalRPN(List<String> params)
    {
        BigDecimal result = null;
        if (null != params && !params.isEmpty())
        {
            Deque<String> stack = new ArrayDeque<>();
            
            for (String param : params)
            {
                if (!OPERATORS.contains(param))
                    stack.push(param);
                else
                {
                    BigDecimal b = new BigDecimal(stack.pop());
                    BigDecimal a = new BigDecimal(stack.pop());
                    BigDecimal res = null;
                    
                    switch (param)
                    {
                        case "+":
                            res = a.add(b);
                            break;
                        case "-":
                            res = a.subtract(b);
                            break;
                        case "*":
                            res = a.multiply(b);
                            break;
                        case "/":
                            res = a.divide(b);
                            break;
                    }
                    
                    if (null != res)
                        stack.push(String.valueOf(res));
                    else
                        throw new IllegalStateException("Invalid operator");
                }
            }
            
            result = new BigDecimal(stack.pop());
        }
        return result;
    }
    
}
